<?php
/**
 * Loads Visual Event files and displays a button in the upper left corner.
 *
 * Visual Event allows you to see events attached to dom elements.
 *
 * {@link http://www.sprymedia.co.uk/article/Visual+Event+2} for more information.
 *
 *
 *
 * Very simple wrapper.  Alternative is to install this as a bookmarklet.
 *
 * @author Mario De Weerd
 * @license GPL V2.
 */
class EVisualEvent extends CWidget {

    /**
     * (non-PHPdoc)
     * @see CWidget::init()
     */
    public function init() {
        /* Call the initializing function */
        $this->_init();
    }

    /** @var array Parsers to load.  Choose from 'dom0','extjs','glow','jQuery','jsBase','mootools','prototyp','yui2'. */
    public $parsers=array('jquery','dom0');

    /**
     * Initialize the widget - include assets in the web page when debugging.
     */
    private function _init() {
        if(YII_DEBUG) {
            /* @var $am CAssetManager */
            $am=Yii::app()->assetManager;
            $path = $ap=$am->publish(dirname(__FILE__).DIRECTORY_SEPARATOR."assets");
            $style="#veButton {position:fixed;float;right;right:0;border-left:solid 1px #e20;border-bottom:solid 1px #e20;top:0;background-color:rgba(240,32,0,0.25);top:0;color:#555;z-index:60000;";
            $cs=Yii::app()->clientScript;
            $cs->registerCoreScript('jquery');
            $cs->registerCss(__FILE__, $style);
            $cssFiles=array('shCore.css','VisualEvent.css');
            $jsFiles=array('shCore.js',/*'VisualEvent_Loader.js',*/'VisualEvent.js');
            $parsers=$this->parsers;
            foreach($cssFiles as $f) {
                $cs->registerCssFile("$path/css/$f");
            }
            foreach($jsFiles as $j) {
                $cs->registerScriptFile("$path/js/$j");
            }
            foreach($parsers as $p) {
                $cs->registerScriptFile("$path/js/parsers/$p.js");
            }
        }
    }

    /**
     * (non-PHPdoc)
     * @see CWidget::run()
     */
    public function run() {
        if(YII_DEBUG) {
            /** Add a link to the page */
            echo CHtml::link('ve','javascript:new VisualEvent();',array('id'=>'veButton'));
        }
    }
}